/*---------------------------------------------------------------------------*/
// Project Name : CpuInfo.dll
//      Licence : GNU GPL
//       Author : hiyohiyo
//         Mail : hiyohiyo@crystalmark.info
//          Web : http://crystalmark.info/
/*---------------------------------------------------------------------------*/

#include <windows.h>
#include "msrnt.h"
#include "InstDrv.h"

HANDLE handle = NULL;

#define	ERROR_MESSAGE "LoadDriver failure!"
#define	ERROR_CAPTION "Error"

static BOOL IsNT();

static BOOL IsNT()
{
	OSVERSIONINFO OSVersionInfo;
	OSVersionInfo.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx(&OSVersionInfo);
	
	return OSVersionInfo.dwPlatformId == VER_PLATFORM_WIN32_NT;
}

BOOL APIENTRY DllMain(HANDLE hModule, 
                      DWORD  ul_reason_for_call, 
                      LPVOID lpReserved)
{
    switch( ul_reason_for_call ) {
    case DLL_PROCESS_ATTACH:
		if(IsNT()) {
			if( LoadDriver(DRIVER_FILE_NAME,DRIVER_NAME) == FALSE ){
				MessageBox(NULL,ERROR_MESSAGE,ERROR_CAPTION,MB_OK);
			}
		}
		break;
	case DLL_THREAD_ATTACH:
		break;
    case DLL_THREAD_DETACH:
		break;
    case DLL_PROCESS_DETACH:
		if(IsNT()) {
			UnloadDriver(DRIVER_NAME);
		}
		break;
    }
    return TRUE;
}
