#include <windows.h>
#include <stdlib.h>
#include <string.h>
#include "InstDrv.h"

extern HANDLE handle;

static BOOL OpenDriver();
static BOOL LoadDeviceDriver(char *FileName, char *DriverName);

BOOL OpenDriver()
{
	handle = CreateFile(
		DRIVER_NAME_FULL,
        GENERIC_READ | GENERIC_WRITE,
        FILE_SHARE_READ,
        NULL,
        OPEN_EXISTING,
        0,
        NULL
        );

    if(handle == INVALID_HANDLE_VALUE)
    {
        return FALSE;
    }
	return TRUE;
}

BOOL LoadDeviceDriver(char *FileName, char *DriverName)
{
    SC_HANDLE	hSCManager;
    SC_HANDLE	hService;
    SERVICE_STATUS	serviceStatus;
    BOOL	ret = FALSE;

	// T[rXRg[}l[WJ
	hSCManager = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);
	if(!hSCManager)
		return FALSE;

	// ɃhCo[݂邩mF邽߂ɃhCo[J
	hService = OpenService( hSCManager,
							DriverName,
							SERVICE_ALL_ACCESS);

	if(hService){
		// ɓ삵Ăꍇ͒~č폜
		// ʏ̓hCo[݂ƂLoadDriverĂяoȂ̂ŕi͂肦Ȃ
		// hCöُ킪l
		ret = ControlService(hService, SERVICE_CONTROL_STOP, &serviceStatus);
		ret = DeleteService(hService);
		CloseServiceHandle(hService);
	}

	// hCo[o^
	hService = CreateService(hSCManager,
		DriverName,
		DriverName,
		SERVICE_ALL_ACCESS,
		SERVICE_KERNEL_DRIVER,
		SERVICE_DEMAND_START,
		SERVICE_ERROR_NORMAL,
		FileName,
		NULL,NULL,NULL,NULL,NULL);

    if(hService){
		// hCo[Jn
		ret = StartService(hService, 0, NULL);
		// nh
		CloseServiceHandle(hService);
	}
	// T[rXRg[}l[W
	CloseServiceHandle(hSCManager);

	return ret;
}

BOOL LoadDriver(char *FileName, char *DriverName)
{
	char str[MAX_PATH],tmp[MAX_PATH];
	char *p;

	//hCo[I[vĂ݂
	if(OpenDriver()) {
		return TRUE;
	}

	//I[vłȂꍇ̓hCo[̓o^AJnB

    // hCo[̓o^AJn
	GetModuleFileName(NULL,str,MAX_PATH);
	if ( (p = strrchr(str,'\\')) != NULL ){
		*p = '\0';
	}
	wsprintf(tmp,"%s\\%s",str,FileName);
	wsprintf(str,"\\\\.\\%s",tmp);

	if(LoadDeviceDriver(tmp, DriverName) == FALSE){
		return FALSE;
	}

	// hCo[I[v
	if(OpenDriver()) {
		return TRUE;
	}
	// hCo[I[vłȂꍇ
	return FALSE;
}

BOOL UnloadDriver(char *DriverName)
{
	SC_HANDLE	hSCManager;
	SC_HANDLE	hService;
	SERVICE_STATUS  serviceStatus;
	BOOL	ret = FALSE;

	// T[rXRg[}l[WJ
    hSCManager = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);
	if(!hSCManager)
		return FALSE;

    // hCo[̃T[rXJ
    hService = OpenService(hSCManager, DriverName, SERVICE_ALL_ACCESS);

	if(hService) {
	    // hCo[~ 
	    ret = ControlService(hService, SERVICE_CONTROL_STOP, &serviceStatus);
	    // hCo[̓o^
	    if(ret == TRUE)
	        ret = DeleteService(hService);
	    // nh
	    CloseServiceHandle(hService);
	}
	// T[rXRg[}l[W
    CloseServiceHandle(hSCManager);
	CloseHandle(handle);
	handle = NULL;

    return ret;
}
