/*---------------------------------------------------------------------------*/
// Project Name : CpuInfo.dll
//      Licence : GNU GPL
//       Author : hiyohiyo
//         Mail : hiyohiyo@crystalmark.info
//          Web : http://crystalmark.info/
/*---------------------------------------------------------------------------*/

#include "SysInfo.h"

extern "C" __declspec (dllexport) ISysInfo* CreateSysInfo(DWORD code)
{
	return new CSysInfo(code);
}

extern "C" __declspec (dllexport) void DestroySysInfo(ISysInfo* p)
{
	delete (CSysInfo*)p;
}

int	CSysInfo::GetData( DWORD ID , DWORD* pData )
{
	if(ID == SI_STATUS){
		return FlagStatus;
	}
	// CPU UPDATE
	if(ID >= CPU_UPDATE_BASE && ID < CPU_UPDATE_BASE + 32)
	{
		if(CPU != NULL){
			delete CPU;
		}
		// mask //
		DWORD mask = 1 << (ID - CPU_UPDATE_BASE);
		CPU = new CCpuInfo( mask );
		*pData = 0;
		return 0;
	}
	if(ID >= CPU_BASE && ID < CPU_BASE + 0xFFF && CPU != NULL){return CPU->GetData( ID , pData );}

	*pData = -1;
	return -1;
}

int CSysInfo::GetString( DWORD ID , char* s )
{
	if(ID >= CPU_BASE && ID < CPU_BASE + 0xFFF && CPU != NULL){return CPU->GetString( ID , s );}
	
	// CSysInfo //
	switch ( ID )
	{
		case	SI_VERSION:		strcpy(s,CPU_INFO_VERSION);	break;
		case	SI_DATE:		strcpy(s,CPU_INFO_DATE);	break;
		case	SI_AUTHOR:		strcpy(s,CPU_INFO_AUTHOR);	break;
				break;
		default:
			strcpy(s,"");
			return -1;
	}
	return 0;
}